Bug 822981 - binutils 2.22.52.0.1 miscompiles the kernel
binutils 2.22.52.0.1 miscompiles the kernel
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: binutils (Show other bugs)
17
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Nick Clifton
Fedora Extras Quality Assurance
RejectedBlocker
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-18 12:52 EDT by Josh Boyer
Modified: 2013-08-01 01:39 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-08-01 01:38:57 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Import of fix for PR14052 (2.78 KB, patch)
2012-05-22 10:51 EDT, Nick Clifton
no flags Details | Diff

  None (edit)
Description Josh Boyer 2012-05-18 12:52:28 EDT
Description of problem:

A change in binutils 2.22.52.0.1 causes empty sections that are relative to be absolute instead.  This causes some problems when building a 32-bit kernel and having it relocated as sections that are supposed to be relative are marked absolute and break the boot.

https://lkml.org/lkml/2012/5/18/230

Version-Release number of selected component (if applicable):

binutils-2.22.52.0.1-10.fc17.i686


How reproducible:

Always from what I can tell.

Steps to Reproduce:
1. Build a kernel with the above binutils
2. Look at system.map and see if __init_begin and __init_end are absolute symbols (among others)
3. Have something relocate the kernel and watch it crash
  
Actual results:

Symbols are absolute

Expected results:

symbols are relative

Additional info:

We've not seen anything along the lines of actual bug reports in the kernel because of this to my knowledge.  Peter Jones mentioned that we don't normally relocate kernels on BIOS machines, but we do on EFI so this might be important.

H.J. suggests that 2.22.52.0.2 is similarly broken.  The upstream binutils report is here:

http://sourceware.org/bugzilla/show_bug.cgi?id=14052
Comment 1 Josh Boyer 2012-05-18 13:06:09 EDT
While the problem exhibits itself on 32-bit kernels because we postprocess them, it isn't strictly limited to 32-bit.  An x86_64 kernel built with the same version of binutils also has the same section being marked as absolute.
Comment 2 Adam Williamson 2012-05-18 13:27:20 EDT
If the only practical impact of this would be booting a 32-bit kernel EFI, then I'm -1 blocker, because we don't support that. If this is all theoretically Bad and Scary but does not in actual fact break anything noticeable for any supported use case (32-bit BIOS boot, 64-bit BIOS and EFI boots) then there's no reason to block release for it.



-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 3 Peter Jones 2012-05-18 14:22:52 EDT
Well, 32-bit EFI isn't a concern since we don't ship that at all.  The cases where we'd hit this appear to be: 1) 32-bit BIOS + kdump (which I doubt if there are that many users of) and 2) some 32-bit BIOS systems with really strange memory maps.  I don't think these are very common either, since we didn't relocate for *years* and it wasn't a big problem on BIOS systems.

So I'm also -1 on blocker status, but I could be +1 for NTH if there's a clean fix.  Note that the fix mentioned on irc won't help case #2, since the hardware in question would still not work.
Comment 4 Tim Flink 2012-05-18 17:32:55 EDT
Discussed in the 2012-05-18 blocker bug review meeting. Rejected as a blocker for Fedora 17 final because the only way that a user could hit this on a configuration supported by Fedora is using kdump with a 32-bit kernel or using uncommon hardware. As such, it can be fixed with an update and not a blocker.
Comment 5 Nick Clifton 2012-05-22 10:51:54 EDT
Created attachment 586057 [details]
Import of fix for PR14052

This patch replaces binutils-2.22.52.0.1-ld-13621.patch.  It is an import of the fix for the upstream PR 14052, and will be applied to the F17 binutils once the release is out.

The rawhide binutils do not need this patch.
Comment 6 Fedora End Of Life 2013-07-03 21:19:35 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 7 Fedora End Of Life 2013-08-01 01:39:02 EDT
Fedora 17 changed to end-of-life (EOL) status on 2013-07-30. Fedora 17 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.